package com.gic.demo.base.api.common;

import java.io.Serializable;

/**
 * 服务响应
 *
 * @param <T> 返回类型
 * @author zhurz
 */
public class ServiceResponse<T> implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 是否走完正常业务逻辑流程
     */
    private boolean success;

    /**
     * 响应代码
     */
    private int code;

    /**
     * 响应信息（可为null，不一定和code说明信息一致）
     */
    private String message;

    /**
     * 响应结果
     */
    private T result;

    public ServiceResponse() {
    }

    public ServiceResponse(boolean success, int code, T result) {
        this(success, code, null, result);
    }

    public ServiceResponse(boolean success, int code, String message, T result) {
        this.success = success;
        this.code = code;
        this.message = message;
        this.result = result;
    }

    public boolean isSuccess() {
        return success;
    }

    public void setSuccess(boolean success) {
        this.success = success;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public T getResult() {
        return result;
    }

    public void setResult(T result) {
        this.result = result;
    }
}

