package com.gic.demo.common.utils;

import com.alibaba.fastjson.JSON;
import ma.glasnost.orika.MapperFacade;
import ma.glasnost.orika.MapperFactory;
import ma.glasnost.orika.impl.DefaultMapperFactory;

import java.util.List;

public class EntityUtils {

    public static <T> T changeEntityByJSON(Class<T> target, Object baseTO) {
        return JSON.parseObject(JSON.toJSONString(baseTO), target);
    }

    public static <T> List<T> changeEntityListByJSON(Class<T> target, Object baseTO) {
        return JSON.parseArray(JSON.toJSONString(baseTO), target);
    }


    private static final MapperFacade MAPPER;

    static {
        MapperFactory mapperFactory = new DefaultMapperFactory.Builder().build();
        MAPPER = mapperFactory.getMapperFacade();
    }

    public static <T> T changeEntityByOrika(Class<T> target, Object baseTO) {
        return MAPPER.map(baseTO, target);
    }

    public static <D, S> List<D> changeEntityListByOrika(Class<D> target, Iterable<S> baseTO) {
        return MAPPER.mapAsList(baseTO, target);
    }

}
