package com.gic.demo.common.utils;

import java.util.*;

/**
 * MAP工具类
 *
 * @author zhurz
 */
public class MapUtil {

    public interface Handler<T, R> {
        R apply(T input);
    }

    /**
     * 转换MAP
     *
     * @param list
     * @param handler
     * @param <K>
     * @param <V>
     * @return
     */
    public static <K, V> Map<K, V> convertMap(List<V> list, Handler<V, K> handler) {
        Map<K, V> map = new HashMap<>();
		if (list == null || handler == null) {
			return map;
		}
        for (V v : list) {
            map.put(handler.apply(v), v);
        }
        return map;
    }

    /**
     * 转换SET
     *
     * @param list
     * @param handler
     * @param <K>
     * @param <V>
     * @return
     */
    public static <K, V> Set<K> convertSet(List<V> list, Handler<V, K> handler) {
        Set<K> set = new HashSet<>();
		if (list == null || handler == null) {
			return set;
		}
        for (V v : list) {
            set.add(handler.apply(v));
        }
        return set;
    }
    
}
